/*******************************************************************************
*  skST7735x - ST7735`bvTFT-LCDp֐Cũwb_t@C           *
*              ST7735R/S`bv(ΐF^u)̂݊mF                     *
*                                                                              *
*              ̃CuMLA"fileio"gē삳o[WłB   *
*                                                                              *
* ============================================================================ *
*   VERSION  DATE        BY                    CHANGE/COMMENT                  *
* ---------------------------------------------------------------------------- *
*   1.00     2019-05-15  ޒH[     Create                                 *
* ============================================================================ *
*  PIC 24EP256MC202 24FJ64GB002 18F26K22                                       *
*  MPLAB X(v5.15)                                                              *
*  MPLAB(R) XC8  C Compiler Version 1.40                                       *
*  MPLAB(R) XC16 C Compiler Version 1.30                                       *
*******************************************************************************/
#ifndef _SKST7735X_H_
#define _SKST7735X_H_

#include <stdint.h>
#include "skSDfileio.h"

// __delay_ms__delay_usׂ̈ɕKv
#if defined(__PIC24E__) || defined(__PIC24F__)
 #ifndef FCY
  // Unless already defined assume 32MHz(16MIPS) system frequency
  #define FCY 16000000UL      // Fosc/2(16MIPS)
  #include <libpic30.h>
 #endif
#else
 // PIC12F PIC16F PIC18F p
 #ifndef _XTAL_FREQ
  // Unless already defined assume 32MHz system frequency
  #define _XTAL_FREQ 32000000 // gpPICɂ蓮glݒ肷
 #endif
#endif

/*******************************************************************************
*	萔̒`                                                                *
*******************************************************************************/
// `bvƃfBXvC̏
#define CHIP_ST7735X       0x01    // Rg[-hb`bv ST7735R/S
#define DISPLAY_TYPE_1     0x10    // 1.8C` 18rbgJ[ 128x160hbg(ΐF^u)

#define DISPLAY_COLUMN128  128     // fBXvC̗128hbg
#define DISPLAY_ROW160     160     // fBXvC̍s160hbg
#define DISPLAY_COLUMN132  132     // fBXvC̗132hbg
#define DISPLAY_ROW162     162     // fBXvC̍s162hbg

// SPIs̐ݒ
#define TFT_DC LATBbits.LATB15     // SPIf[^̃p[^̓R}hIs
#define TFT_CS LATBbits.LATB14     // TFT_LCDW[Is
// "DRV_SPI_CONFIG_CHANNEL_1_ENABLE""drv_spi_config.h"ɋLqL
#if defined(DRV_SPI_CONFIG_CHANNEL_1_ENABLE)
#define SPI_CHANNEL          1     // SPI1g
#else
#define SPI_CHANNEL          2     // SPI2g
#endif

// R}hƃp[^̏
#define ST7735X_COMMAND       0    // SOĨf[^̓R}hw
#define ST7735X_PARAMETER     1    // SOĨf[^̓p[^w

#define ST7735X_CMD_SWREST    0x01 // \tgEFAZbg
#define ST7735X_CMD_SLPIN     0x10 // X[v
#define ST7735X_CMD_SLPOUT    0x11 // X[v̕A
#define ST7735X_CMD_INVOFF    0x20 // ]\nee
#define ST7735X_CMD_INVON     0x21 // ]\nm
#define ST7735X_CMD_DISPOFF   0x28 // fBXvCnee
#define ST7735X_CMD_DISPON    0x29 // fBXvCnm
#define ST7735X_CMD_CASET     0x2A // AhX̐ݒ
#define ST7735X_CMD_RASET     0x2B // sAhX̐ݒ
#define ST7735X_CMD_RAMWR     0x2C // ɏ
#define ST7735X_CMD_MADCTL    0x36 // 
#define ST7735X_CMD_COLMOD    0x3A // F̊Kw肷

#define ST7735X_PARA_12COLOR  3    // 12rbgJ[(R:4 G:4 B:4)w肷
#define ST7735X_PARA_16COLOR  5    // 16rbgJ[(R:5 G:6 B:5)w肷
#define ST7735X_PARA_18COLOR  6    // 18rbgJ[(R:6 G:6 B:6)w肷

#define BLACK_SCREEN          0
#define WHITE_SCREEN          1


/******************************************************************************/
/*  ֐̃vg^Cv錾                                                    */
/******************************************************************************/
     void LCD_DisplayInit() ;
     void LCD_SendByte(uint8_t value, uint8_t dc) ;
     void LCD_SendWord(uint16_t value) ;
     uint8_t LCD_RangSET(uint16_t xs, uint16_t xe, uint16_t ys, uint16_t ye) ;

     void LCD_begin(uint8_t dspinfo,uint8_t value) ;
     void LCD_DisplayDirection(uint8_t value) ;
     void LCD_CLS(uint8_t value) ;
     void LCD_ColorSet(uint8_t red, uint8_t green, uint8_t blue) ;
     void LCD_ReduceColorSet(uint8_t red, uint8_t green, uint8_t blue) ;
     void LCD_PutPixel(uint16_t xp, uint16_t yp) ;
     void LCD_Circle(uint16_t xp, uint16_t yp, uint16_t radius) ;
     void LCD_FillCircle(uint16_t xp, uint16_t yp, uint16_t radius) ;
     void LCD_Line(uint16_t xsp, uint16_t ysp, uint16_t xep, uint16_t yep) ;
     void LCD_Box(uint16_t xsp, uint16_t ysp, uint16_t xep, uint16_t yep) ;
     void LCD_FillBox(uint16_t xsp, uint16_t ysp, uint16_t xep, uint16_t yep) ;
     void LCD_Putc(uint16_t xp, uint16_t yp, uint8_t c) ;
     void LCD_Puts(uint16_t xp, uint16_t yp, const char *s) ;
     void LCD_Putc2x(uint16_t xp, uint16_t yp, uint8_t c) ;
     void LCD_Puts2x(uint16_t xp, uint16_t yp, const char *s) ;
     void LCD_SleepCtl(uint8_t sel) ;
     void LCD_DisplayINV(uint8_t sel) ;

#endif
